import {
	JupyterFrontEnd, JupyterFrontEndPlugin
} from '@jupyterlab/application';

import {
	NotebookPanel, INotebookTracker, Notebook
} from '@jupyterlab/notebook';

import {
	CodeCell
} from '@jupyterlab/cells';


import './codemirror-finesse';

/**
 * The plugin registration information.
 */
const plugin: JupyterFrontEndPlugin<void> = {
	activate,
	id: 'finesse-syntax-jupyter',
	requires: [INotebookTracker],
	autoStart: true
};

function activate(app: JupyterFrontEnd, tracker: INotebookTracker) {
	tracker.widgetAdded.connect(activate_finesse)
};


function check_syntax(sender: Notebook): void {
	sender.widgets.forEach(cell => {
		if (cell instanceof CodeCell && cell.model.mimeType != "text/x-finesse-python") {
			cell.model.mimeType = "text/x-finesse-python";
		}
	});
};

function activate_finesse(sender: INotebookTracker, panel: NotebookPanel): void {
	panel.content.modelContentChanged.connect(check_syntax);
};

/**
 * Export the plugin as default.
 */
export default plugin;
